; ============================
;  Fellow Amiga Emulator      
;  Blitter (OCS) Emulation
;  (C) 1994-1998 Petter Schau 
; ============================

        .586p
DGROUP group _DATA,_BSS
_TEXT  segment para public use32 'CODE'
       assume cs:_TEXT, ds:DGROUP, ss:DGROUP

public blitstart_
blitstart_:                             ; Used to check code alignment
startlbl:

include defs.inc
include func\bus.inc
include func\copper.inc
include func\memory.inc
	
include mac\bus.mac

	
;==========================
; Blitter IO register stubs
;==========================


BLIT_FINISH macro
local		l1
		test	byte ptr [_blitterstatus], 0ffh
		jz	l1
		pushad
		call	finish_blit_
		popad
l1:
endm


;========
; BLTCON0
;========
; $dff040


                ALIGN32

public wbltcon0_
wbltcon0_:	BLIT_FINISH
		mov	word ptr [_bltcon + 2], dx
		and	edx, 0ffh
		mov	edx, dword ptr [_blit_min_functable + 4*edx]
		mov	dword ptr [_bltminterm], edx
		ret


;=========
; BLTCON0L
;=========
; $dff05A


                ALIGN32

public wbltcon0l_
wbltcon0l_:	BLIT_FINISH
		mov	byte ptr [_bltcon + 2], dl
		and	edx, 0ffh
		mov	edx, dword ptr [_blit_min_functable + 4*edx]
		mov	dword ptr [_bltminterm], edx
		ret


;========
; BLTCON1
;========
; $dff042


                ALIGN32

public wbltcon1_
wbltcon1_:	BLIT_FINISH
		mov	dword ptr [_bltdesc], 2
		test	edx, 2				; Test descending mode
		jz	blits1
		mov	dword ptr [_bltdesc], -2
blits1:		mov	ecx, dword ptr [_bltcon]
		mov	word ptr [_bltcon], dx
		test	edx, 1				; Line mode?
		jnz	bconlines
		test	ecx, 1		; Going from linemode to desc mode?
		jz	bconnoprevlines

		; Here last mode was linemode, but new isn't
		; Mods need changing if new is desc mode

		test	edx, 2
		jz	bcon		; New is normal, mods already ok
		jmp	modrestore

bconnoprevlines:and	edx, 2
		and	ecx, 2
		cmp	edx, ecx
		je	bcon
modrestore:	neg	dword ptr [_bltamod]
		neg	dword ptr [_bltbmod]
		neg	dword ptr [_bltcmod]
		neg	dword ptr [_bltdmod]
bcon:		ret
bconlines:	test	ecx, 1	; Restore unless previous mode was linemode
		jnz	bcon
		test	ecx, 2
		jz	bcon
		jmp	modrestore


;========
; BLTAFWM
;========
; $dff044


                ALIGN32

public wbltafwm_
wbltafwm_:	BLIT_FINISH
		mov	word ptr [_bltafwm], dx
		mov	word ptr [_bltafwm + 2], dx
		ret


;========
; BLTALWM
;========
; $dff046


                ALIGN32

public wbltalwm_
wbltalwm_:	BLIT_FINISH
		mov	word ptr [_bltalwm], dx
		mov	word ptr [_bltalwm + 2], dx
		ret


;=======
; BLTCPT
;=======
; $dff048 - WORD


                ALIGN32

public wbltcpth_
wbltcpth_:	BLIT_FINISH
		and	edx, 01fh
		mov	word ptr [_bltcpt + 2], dx
		ret


; $dff04a - WORD


                ALIGN32

public wbltcptl_
wbltcptl_:	BLIT_FINISH
		and	edx, 0fffffffeh
		mov	word ptr [_bltcpt], dx
		ret


;=======
; BLTBPT
;=======
; $dff04c - WORD


                ALIGN32

public wbltbpth_
wbltbpth_:	BLIT_FINISH
		and	edx, 01fh
		mov	word ptr [_bltbpt + 2], dx
		ret


; $dff04e - WORD


                ALIGN32

public wbltbptl_
wbltbptl_:	BLIT_FINISH
		and	edx, 0fffffffeh
		mov	word ptr [_bltbpt], dx
		ret


;=======
; BLTAPT
;=======
; $dff050 - WORD


                ALIGN32

public wbltapth_
wbltapth_:	BLIT_FINISH
		and	edx, 01fh
		mov	word ptr [_bltapt + 2], dx
		ret


; $dff052 - WORD


                ALIGN32

public wbltaptl_
wbltaptl_:	BLIT_FINISH
		and	edx, 0fffffffeh
		mov	word ptr [_bltapt], dx
		ret


;=======
; BLTDPT
;=======
; $dff054 - WORD


                ALIGN32

public wbltdpth_
wbltdpth_:	BLIT_FINISH
		and	edx, 01fh
		mov	word ptr [_bltdpt + 2], dx
		ret


; $dff056 - WORD


                ALIGN32

public wbltdptl_
wbltdptl_:	BLIT_FINISH
		and	edx, 0fffffffeh
		mov	word ptr [_bltdpt], dx
		ret


;========
; BLTSIZE
;========
; $dff058


                ALIGN32

public wbltsize_
wbltsize_:	BLIT_FINISH
		mov	ecx, edx
		and	ecx, 03fh		; Width
		jnz	wbltsizea
		mov	ecx, 64
wbltsizea:	mov	dword ptr [_linelength], ecx
		shr	edx, 6			; Height
		and	edx, 3ffh
		jnz	wbltsizeb
		mov	edx, 1024
wbltsizeb:	mov	dword ptr [_linenum], edx
		mov	dword ptr [_linecount], edx
		test	byte ptr [_dmacon], 40h
		jnz	blitter_copy_
		mov	dword ptr [_blitterdmawaiting], 1
		ret


;========
; BLTSIZV
;========
; $dff05C


                ALIGN32

public wbltsizv_
wbltsizv_:	BLIT_FINISH
		and	edx, 07fffh		; Height
		jnz	wbltsizva
		mov	edx, 08000h
wbltsizva:	mov	dword ptr [_linenum], edx
		ret


;========
; BLTSIZH
;========
; $dff05E


                ALIGN32

public wbltsizh_
wbltsizh_:	BLIT_FINISH
		and	edx, 07ffh		; Width
		jnz	wbltsizha
		mov	edx, 0800h
wbltsizha:	mov	dword ptr [_linelength], edx
		mov	edx, dword ptr [_linenum]
		mov	dword ptr [_linecount], edx
		test	byte ptr [_dmacon], 40h
		jnz	blitter_copy_
		mov	dword ptr [_blitterdmawaiting], 1
		ret


;========
; BLTCMOD
;========
; $dff060


                ALIGN32

public wbltcmod_
wbltcmod_:	BLIT_FINISH
		and	edx, 0fffeh		; Even modulo
		movsx	edx, dx
		test	byte ptr [_bltcon], 1
		jnz	bcn
		test	byte ptr [_bltcon], 2
		jz	bcn
		neg	edx
bcn:		mov	dword ptr [_bltcmod], edx
		ret


;========
; BLTBMOD
;========
; $dff062


                ALIGN32

public wbltbmod_
wbltbmod_:	BLIT_FINISH
		and	edx, 0fffeh		; Even modulo
		movsx	edx, dx
		test	byte ptr [_bltcon], 1
		jnz	bbn
		test	byte ptr [_bltcon], 2
		jz	bbn
		neg	edx
bbn:		mov	dword ptr [_bltbmod], edx
		ret


;========
; BLTAMOD
;========
; $dff064


                ALIGN32

public wbltamod_
wbltamod_:	BLIT_FINISH
		and	edx, 0fffeh		; Even modulo
		movsx	edx, dx
		test	byte ptr [_bltcon], 1
		jnz	ban
		test	byte ptr [_bltcon], 2
		jz	ban
		neg	edx
ban:		mov	dword ptr [_bltamod], edx
		ret


;========
; BLTDMOD
;========
; $dff066


                ALIGN32

public wbltdmod_
wbltdmod_:	BLIT_FINISH
		and	edx, 0fffeh		; Even modulo
		movsx	edx, dx
		test	byte ptr [_bltcon], 1
		jnz	bdn
		test	byte ptr [_bltcon], 2
		jz	bdn
		neg	edx
bdn:		mov	dword ptr [_bltdmod], edx
		ret


;========
; BLTCDAT
;========
; $dff070


                ALIGN32

public wbltcdat_
wbltcdat_:	BLIT_FINISH
		mov	dword ptr [_bltcdat], edx
		ret


;========
; BLTBDAT
;========
; $dff072


                ALIGN32

public wbltbdat_
wbltbdat_:	BLIT_FINISH
		mov	dword ptr [_bltbdatoriginal], edx
		mov	ecx, dword ptr [_bltcon]
		shr	ecx, 12
		and	ecx, 0fh
		test	dword ptr [_bltcon], 2
		jnz	wbltbdatb
		shr	dx, cl
		and	edx, 0ffffh
		mov	dword ptr [_bltbdat], edx
		ret
wbltbdatb:	shl	dx, cl
		and	edx, 0ffffh
		mov	dword ptr [_bltbdat], edx
		ret


;========
; BLTADAT
;========
; $dff074


                ALIGN32

public wbltadat_
wbltadat_:	BLIT_FINISH
		mov	dword ptr [_bltadat], edx
		mov	dword ptr [_bltadatoriginal], edx
		ret


; ===========================================
; Entrypoint for blitter operations
; ===========================================

; -------------------------------------------
; Assume never called when blitter dma is off
; Only calculate the cyclecount
; Set blitend to the cycle when the blit ends
; Set the blitter not ready flag in dmacon
; If blitpri is on, write the cyclecount to
; thiscycle
; -------------------------------------------
extern logblit_:near

		ALIGN32

public blitter_copy_
blitter_copy_:	push	ebx
		push	eax
		mov	dword ptr [_bltzero], 0
		mov	eax, dword ptr [_bltcon]
		shr	eax, 24				; calc cycles
		and	eax, 0fh
		test	dword ptr [_bltcon], 1
		jnz	linecyc
		mov	ebx, dword ptr [_blit_cycletab + 4*eax]
		jmp	nolinecyc
linecyc:	mov	ebx, 6           
nolinecyc:	test	byte ptr [_blit_fast], 0ffh
		jnz	fastblit
		imul	ebx, dword ptr [_linelength]	; cycles per line
		imul	ebx, dword ptr [_linenum]	; total cyclecount
fastblit:	mov	eax, 1				; State 1, no bltpri
		mov	dword ptr [_thiscycle], 0
		test	dword ptr [_dmaconr], 0400h	; test bltpri
		jz	nobltpri
		mov	ah, byte ptr [_bltcon + 3]
		and	ah, 15
		cmp	ah, 1		
		je	nobltpri
		inc	al				; State 2, bltpri blt
		shr	ebx, 1				; Set blitend cycle
		test	byte ptr [_blit_fast], 0ffh
		jnz	nobltpri
		mov	dword ptr [_thiscycle], ebx
nobltpri:	shr	ebx, 1
		add	ebx, dword ptr [_curcycle]
		mov	dword ptr [_blitend], ebx
		mov	ah, 0				; Set blitter busy bit
		or	dword ptr [_dmaconr], 04000h
		mov	dword ptr [_blitterstatus], eax
		SCAN_EVENTS_LVL4
		pop	eax
		pop	ebx
		ret


;=======================================================
; This function does the blit, called on the last cycle
; of the blit.
;=======================================================

	
		ALIGN32

public finish_blit_
finish_blit_:	mov	dword ptr [_blitend], -1
		SCAN_EVENTS_LVL4
		mov	dword ptr [_blitterdmawaiting], 0
		mov	dword ptr [_blitterstatus], 0
		and	dword ptr [_dmaconr], 0bfffh     
		xor	eax, eax
		mov	dword ptr [_leftoverA], eax
		mov	dword ptr [_leftoverB], eax
		mov	ebx, dword ptr [_bltcon]
		test	ebx, 1
		jnz	blitterlinemode
		test	ebx, 18h
		jnz	blitterfillmode
		shr	ebx, 22
		and	ebx, 03ch
		jmp	dword ptr [_blittermodes + ebx]


; ==============================
; Blitter line mode entry point
; ==============================


                ALIGN32


blitterlinemode:

        mov     dword ptr _bltlinepointflag,0
	mov     eax,dword ptr _linecount
	mov     dword ptr _bltlineheight,eax     ; Line height
        mov     eax,dword ptr _bltcon
        mov     ecx,eax
        shr     ecx,28
        and     ecx,00fh         

        and     eax,1ch
        mov     ebx,ecx

        mov     bp,word ptr _bltapt   ; edi is decision variable
        mov     esi,dword ptr _bltcpt     ; get C data adress
        mov     edi,dword ptr _bltdpt     ; get destination adress
        add     esi,offset _cmem
        add     edi,offset _cmem
        sub     esi,2

        mov     edx,dword ptr _bltbdatoriginal
        mov     ecx,dword ptr _bltcon
        shr     ecx,12
        and     ecx,0fh
        ror     dx,cl
        mov     dword ptr _bltbdatline,edx
        xor     ecx,ecx
        test    edx,1
        jz      bliq
        mov     ecx,-1
bliq:


        jmp     dword ptr _bltlinesudsulaul[eax]  ; Jump to correct draw routine


;===============================================
; SUD/SUL/AUL = 000
; Line goes down to the right, Y is independent
;
; Registers:
; ebp - D
; esi - cpt
; edi - dpt
; ebx - bltadat
; ecx - bltbdat
; edx - bltcdat
; eax - result
;===============================================


                ALIGN32

public blitterlinemodeoctant0_
blitterlinemodeoctant0_:
oct0c:
        test    dword ptr _bltcon,02000000h
        jz      oct0u
        mov     edx,dword ptr [esi]
        bswap   edx
oct0u:
        push    ebx
        push    ecx
        mov     cl,bl
        mov     ebx,dword ptr _bltadat
        shr     bx,cl
        pop     ecx

        call    dword ptr [_bltminterm]

        pop     ebx

        mov     byte ptr [edi],ah    ; Store result
        mov     byte ptr 1[edi],al
	or	dword ptr [_bltzero],eax
        mov     eax,dword ptr _bltcmod
        or      bp,bp                     ; D 
	jns     oct0a            
        add     ebp,dword ptr _bltbmod    ; D < 0 , D = D + 2*sdelta
	jmp     oct0b
oct0a:  add     ebp,dword ptr _bltamod    ; D >= 0, D = D + 2*sdelta-2*ldelta

        inc     ebx
        cmp     ebx,16
        jne     oct0b


        xor     ebx,ebx

        add     esi,2
        add     edi,2
oct0b:  add     esi,eax
        add     edi,eax

        mov     eax,dword ptr _bltbdatline
        rol     ax,1
        mov     dword ptr _bltbdatline,eax
        xor     ecx,ecx
        test    eax,1
        jz      oct0q
        dec     ecx
oct0q:


        dec     dword ptr _bltlineheight
	jnz     oct0c
	jmp     blitterlinemodeend


;=============================================
; SUD/SUL/AUL = 001
; Line goes up to the right, Y is independent
;=============================================


                ALIGN32

public blitterlinemodeoctant1_ 
blitterlinemodeoctant1_: 
oct1c:
        test    dword ptr _bltcon,02000000h
        jz      oct1u
        mov     edx,dword ptr [esi]
        bswap   edx
oct1u:
        push    ebx
        push    ecx
        mov     cl,bl
        mov     ebx,dword ptr _bltadat
        shr     bx,cl
        pop     ecx
        call    dword ptr [_bltminterm]

        pop     ebx

        mov     byte ptr [edi],ah    ; Store result
        mov     byte ptr 1[edi],al
	or	dword ptr [_bltzero],eax
        mov     eax,dword ptr _bltcmod
        or      bp,bp                     ; D < 0
	jns     oct1a            
        add     ebp,dword ptr _bltbmod    ; D < 0 , D = D + 2*sdelta
	jmp     oct1b
oct1a:  add     ebp,dword ptr _bltamod    ; D >= 0, D = D + 2*sdelta-2*ldelta

        inc     ebx
        cmp     ebx,16
        jne     oct1b

        xor     ebx,ebx

        add     edi,2
        add     esi,2
oct1b:  sub     edi,eax
        sub     esi,eax

        mov     eax,dword ptr _bltbdatline
        rol     ax,1
        mov     dword ptr _bltbdatline,eax
        xor     ecx,ecx
        test    eax,1
        jz      oct1q
        dec     ecx
oct1q:

	dec     dword ptr _bltlineheight
	jnz     oct1c
	jmp     blitterlinemodeend


;===============================================
; SUD/SUL/AUL = 010
; Line goes down, to the left, Y is independent
;===============================================


                ALIGN32

public blitterlinemodeoctant2_
blitterlinemodeoctant2_: 
oct2c:

        test    dword ptr _bltcon,02000000h
        jz      oct2u
        mov     edx,dword ptr [esi]
        bswap   edx
oct2u:

        push    ebx
        push    ecx
        mov     cl,bl
        mov     ebx,dword ptr _bltadat
        shr     bx,cl
        pop     ecx


        call    dword ptr [_bltminterm]

        pop     ebx

        mov     byte ptr [edi],ah    ; Store result
        mov     byte ptr 1[edi],al
	or	dword ptr [_bltzero],eax
        mov     eax,dword ptr _bltcmod
        or      bp,bp                     ; D < 0
	jns     oct2a            
        add     ebp,dword ptr _bltbmod    ; D < 0 , D = D + 2*sdelta
	jmp     oct2b
oct2a:  add     ebp,dword ptr _bltamod    ; D >= 0, D = D + 2*sdelta-2*ldelta
        dec     ebx
        jns     oct2b

        mov     ebx,15

        sub     edi,2
        sub     esi,2
oct2b:  add     edi,eax
        add     esi,eax

        mov     eax,dword ptr _bltbdatline
        rol     ax,1
        mov     dword ptr _bltbdatline,eax
        xor     ecx,ecx
        test    eax,1
        jz      oct2q
        dec     ecx
oct2q:

        dec     dword ptr _bltlineheight
	jnz     oct2c
	jmp     blitterlinemodeend


;============================================
; SUD/SUL/AUL = 011
; Line goes up to the left, Y is independent
;============================================


                ALIGN32

public blitterlinemodeoctant3_ 
blitterlinemodeoctant3_: 
oct3c:

        test    dword ptr _bltcon,02000000h
        jz      oct3u
        mov     edx,dword ptr [esi]
        bswap   edx
oct3u:

        push    ebx
        push    ecx
        mov     cl,bl
        mov     ebx,dword ptr _bltadat
        shr     bx,cl
        pop     ecx


        call    dword ptr [_bltminterm]

        pop     ebx

        mov     byte ptr [edi],ah    ; Store result
        mov     byte ptr 1[edi],al
	or	dword ptr [_bltzero],eax
        mov     eax,dword ptr _bltcmod
        or      bp,bp                     ; D < 0
	jns     oct3a            
        add     ebp,dword ptr _bltbmod    ; D < 0 , D = D + 2*sdelta
	jmp     oct3b
oct3a:  add     ebp,dword ptr _bltamod    ; D >= 0, D = D + 2*sdelta-2*ldelta


        dec     ebx
        jns     oct3b
        mov     ebx,15

        sub     edi,2
        sub     esi,2
oct3b:  sub     edi,eax
        sub     esi,eax

        mov     eax,dword ptr _bltbdatline
        rol     ax,1
        mov     dword ptr _bltbdatline,eax
        xor     ecx,ecx
        test    eax,1
        jz      oct3q
        dec     ecx
oct3q:

	dec     dword ptr _bltlineheight
	jnz     oct3c
	jmp     blitterlinemodeend


;===============================================
; SUD/SUL/AUL = 100
; Line goes down to the right, X is independent
;===============================================


                ALIGN32

public blitterlinemodeoctant4_ 
blitterlinemodeoctant4_: 
oct4c:

        test    dword ptr _bltcon,02000000h
        jz      oct4u
        mov     edx,dword ptr [esi]
        bswap   edx
oct4u:

        test    dword ptr _bltcon,2       ; Test sing
	jz      oct4e
	test    dword ptr _bltlinepointflag,1 ; No draw if bit already set
	jnz     oct4f
	mov     dword ptr _bltlinepointflag,1
oct4e:

        push    ebx
        push    ecx
        mov     cl,bl
        mov     ebx,dword ptr _bltadat
        shr     bx,cl
        pop     ecx


        call    dword ptr [_bltminterm]

        pop     ebx

        mov     byte ptr [edi],ah    ; Store result
        mov     byte ptr 1[edi],al
	or	dword ptr [_bltzero],eax
oct4f:  or      bp,bp                     ; D < 0
	jns     oct4a            
        add     ebp,dword ptr _bltbmod    ; D < 0 , D = D + 2*sdelta
	jmp     oct4b
oct4a:  mov     eax,dword ptr _bltcmod    ; Y increases
        add     ebp,dword ptr _bltamod    ; D >= 0, D = D + 2*sdelta-2*ldelta
        add     edi,eax
        add     esi,eax
	mov     dword ptr _bltlinepointflag,0 ; enable dot on this line
oct4b:
        inc     ebx
        cmp     ebx,16
        jne     oct4d
        xor     ebx,ebx
        add     edi,2
        add     esi,2
oct4d:


        mov     eax,dword ptr _bltbdatline
        rol     ax,1
        mov     dword ptr _bltbdatline,eax
        xor     ecx,ecx
        test    eax,1
        jz      oct4q
        dec     ecx
oct4q:

        dec     dword ptr _bltlineheight
	jnz     oct4c
	jmp     blitterlinemodeend


;==============================================
; SUD/SUL/AUL = 101
; Line goes down to the left, X is independent
;==============================================


                ALIGN32

public blitterlinemodeoctant5_
blitterlinemodeoctant5_: 
oct5c:
        test    dword ptr _bltcon,02000000h
        jz      oct5u
        mov     edx,dword ptr [esi]
        bswap   edx
oct5u:
        test    dword ptr _bltcon,2
	jz      oct5e
	test    dword ptr _bltlinepointflag,1
	jnz     oct5f
	mov     dword ptr _bltlinepointflag,1
oct5e:

        push    ebx
        push    ecx
        mov     cl,bl
        mov     ebx,dword ptr _bltadat
        shr     bx,cl
        pop     ecx


        call    dword ptr [_bltminterm]

        pop     ebx

        mov     byte ptr [edi],ah    ; Store result
        mov     byte ptr 1[edi],al
	or	dword ptr [_bltzero],eax
oct5f:  or      bp,bp                     ; D < 0
	jns     oct5a            
        add     ebp,dword ptr _bltbmod    ; D < 0 , D = D + 2*sdelta
	jmp     oct5b
oct5a:  mov     eax,dword ptr _bltcmod    ; Y increases
        add     ebp,dword ptr _bltamod    ; D >= 0, D = D + 2*sdelta-2*ldelta
        add     edi,eax
        add     esi,eax
	mov     dword ptr _bltlinepointflag,0
oct5b:
        dec     ebx
        jns     oct5d
        mov     ebx,15

        sub     edi,2
        sub     esi,2
oct5d:
        mov     eax,dword ptr _bltbdatline
        rol     ax,1
        mov     dword ptr _bltbdatline,eax
        xor     ecx,ecx
        test    eax,1
        jz      oct5q
        dec     ecx
oct5q:


        dec     dword ptr _bltlineheight
	jnz     oct5c
	jmp     blitterlinemodeend



;==============================================
; SUD/SUL/AUL = 110
; Line goes up, to the right, X is independent
;==============================================


                ALIGN32

public blitterlinemodeoctant6_
blitterlinemodeoctant6_: 
oct6c:
        test    dword ptr _bltcon,02000000h
        jz      oct6u
        mov     edx,dword ptr [esi]
        bswap   edx
oct6u:

        test    dword ptr _bltcon,2
	jz      oct6e
	test    dword ptr _bltlinepointflag,1
	jnz     oct6f
	mov     dword ptr _bltlinepointflag,1
oct6e:
        push    ebx
        push    ecx
        mov     cl,bl
        mov     ebx,dword ptr _bltadat
        shr     bx,cl
        pop     ecx


        call    dword ptr [_bltminterm]

        pop     ebx

        mov     byte ptr [edi],ah    ; Store result
        mov     byte ptr 1[edi],al
	or	dword ptr [_bltzero],eax
oct6f:  or      bp,bp                     ; D < 0
	jns     oct6a            
        add     ebp,dword ptr _bltbmod    ; D < 0 , D = D + 2*sdelta
	jmp     oct6b
oct6a:  mov     eax,dword ptr _bltcmod    ; Y decreases
        add     ebp,dword ptr _bltamod    ; D >= 0, D = D + 2*sdelta-2*ldelta
        sub     edi,eax
        sub     esi,eax
	mov     dword ptr _bltlinepointflag,0
oct6b:
        inc     ebx
        cmp     ebx,16
        jne     oct6d
        xor     ebx,ebx
        add     edi,2
        add     esi,2
oct6d:
        mov     eax,dword ptr _bltbdatline
        rol     ax,1
        mov     dword ptr _bltbdatline,eax
        xor     ecx,ecx
        test    eax,1
        jz      oct6q
        dec     ecx
oct6q:
        dec     dword ptr _bltlineheight
	jnz     oct6c
	jmp     blitterlinemodeend


;===============================================
; SUD/SUL/AUL = 111
; Line goes up to the left, X is independent
;===============================================


                ALIGN32

public blitterlinemodeoctant7_ 
blitterlinemodeoctant7_: 
oct7c:

        test    dword ptr _bltcon,02000000h
        jz      oct7u
        mov     edx,dword ptr [esi]
        bswap   edx
oct7u:
        test    dword ptr _bltcon,2
	jz      oct7e
	test    dword ptr _bltlinepointflag,1
	jnz     oct7f
	mov     dword ptr _bltlinepointflag,1
oct7e:
        push    ebx
        push    ecx
        mov     cl,bl
        mov     ebx,dword ptr _bltadat
        shr     bx,cl
        pop     ecx


        call    dword ptr [_bltminterm]

        pop     ebx

        mov     byte ptr [edi],ah    ; Store result
        mov     byte ptr 1[edi],al
	or	dword ptr [_bltzero],eax
oct7f:  or      bp,bp                     ; D < 0
	jns     oct7a            
        add     ebp,dword ptr _bltbmod    ; D < 0 , D = D + 2*sdelta
	jmp     oct7b
oct7a:  mov     eax,dword ptr _bltcmod    ; Y decreases
        add     ebp,dword ptr _bltamod    ; D >= 0, D = D + 2*sdelta-2*ldelta
        sub     edi,eax
        sub     esi,eax
	mov     dword ptr _bltlinepointflag,0
oct7b:
        dec     ebx
        jns     oct7d
        mov     ebx,15

        sub     edi,2
        sub     esi,2
oct7d:

        mov     eax,dword ptr _bltbdatline
        rol     ax,1
        mov     dword ptr _bltbdatline,eax
        xor     ecx,ecx
        test    eax,1
        jz      oct7q
        dec     ecx
oct7q:

        dec     dword ptr _bltlineheight
	jnz     oct7c

blitterlinemodeend:
        sub     esi,offset _cmem
        sub     edi,offset _cmem
        add     esi,2
        mov     dword ptr _bltdpt,edi
        mov     dword ptr _bltcpt,esi
        mov     edx,08040h
	mov     ecx,0dff09ch
	call    wriw
	ret




; =================
; Blitter fill mode
; =================


		ALIGN32


; Jump to fill routine

blitterfillmode:shr	ebx,22
		and	ebx,03ch
		jmp	dword ptr [_blitterfillmodes + ebx]


		ALIGN32


; General fill routine that handles any combination of ABCD


public blitterfillline_
blitterfillline_:
		mov	eax,dword ptr [_bltcon]
		mov	dword ptr [_bltfillbltconsave],eax
		test	eax,8
		jz	blitterexfillline

blitterincfillline:
		mov	esi,dword ptr [_linelength]
		mov	eax,dword ptr [_bltcon]
		mov	dword ptr [_bltfillbltconsave],eax
		mov	ebp,dword ptr [_bltdesc]
blitincfillword:
blitincfill1:
		test	eax,08000000h			; Test dma A
		jz	blitincfill2
		mov	ecx,dword ptr [_bltApt]
		mov	edx,dword ptr [_cmem+ecx]
		bswap	edx				; Now, bits 31-16
		cmp	esi,dword ptr [_linelength]	; Do first word masking
		jne	blitincfilld
		and	edx,dword ptr [_bltAFWM]
blitincfilld:
		cmp	esi,1				; Last mask + modulo
		jne	blitincfillf
		mov	ebx,dword ptr [_bltAMOD]
		add	ecx,ebx
		and	edx,dword ptr [_bltALWM]
blitincfillf:
		add	ecx,ebp				; Add +2 or -2 to ptA
		and	edx,0ffff0000h			; Take away garbage
		and	ecx,01ffffeh
		mov	dword ptr [_bltApt],ecx
		mov	ecx,eax				; Saved bltcon to ecx
		shr	ecx,28				; Exctract shift for A

		test	eax,2				; Test desc mode
		jz	blitincnofdesc1
		rol	edx,cl				; To left in desc mode
		jmp	blitincnofdesc2
blitincnofdesc1:
		shr	edx,cl				; Right in forward mode
blitincnofdesc2:
		mov	ecx,dword ptr [_leftoverA]	; get last leftover
		mov	dword ptr [_leftoverA],edx	; Store leftover
		shr	edx,16
		or	edx,ecx				; Merge with leftover
		mov	dword ptr [_bltADAT],edx	; Store data from A
		jmp	blitincfill2x

		; DMA A off
blitincfill2:
		mov	edx,dword ptr [_bltadatoriginal]
		shl	edx,16
		cmp	esi,dword ptr [_linelength]	; First word masking
		jne	bifd
		and	edx,dword ptr [_bltAFWM]
bifd:
		cmp	esi,1				; Last mask + modulo
		jne	biff
		mov	ebx,dword ptr [_bltAMOD]
		add	ecx,ebx
		and	edx,dword ptr [_bltALWM]
biff:
		mov	ecx,eax				; Saved bltcon to ecx
		shr	ecx,28				; Exctract shift for A

		test	eax,2				; Test desc mode
		jz	binofdesc1
		rol	edx,cl
		jmp	binofdesc2
binofdesc1:
		shr	edx,cl
binofdesc2:
		mov	ecx,dword ptr [_leftoverA]	; get last leftover
		mov	dword ptr [_leftoverA],edx	; Store leftover from A
		shr	edx,16
		or	edx,ecx
		mov	dword ptr [_bltADAT],edx	; Store data from A
blitincfill2x:
        test    eax,04000000h              ; Test dma B
        jz      blitincfill3
	mov     ecx,dword ptr [_bltBpt]
	mov     edx,dword ptr [_cmem-2+ecx]
        bswap   edx                        ; My data in lo word
        cmp     esi,1                      ; Do modulo if last word on line 
        jne     blitincfillg
        mov     ebx,dword ptr [_bltBMOD]   ; BLTBMOD
        add     ecx,ebx
blitincfillg:
        add     ecx,ebp                    ; Add ptB with +2 or -2
        and     ecx,01ffffeh               ; For safety
        mov     dword ptr [_bltBpt],ecx    ; Save ptB
        mov     ecx,eax                    ; Extract shift for B
	shr     ecx,12
        and     ecx,0fh
        shl     edx,16                     ; Move my data up, lo is clean

        test    eax,2                      ; Rotate or shift
        jz      blitincnofdesc3
        rol     edx,cl
        jmp     blitincnofdesc4
blitincnofdesc3:
        shr     edx,cl
blitincnofdesc4:


        mov     ecx,dword ptr _leftoverB    ; Old leftover
        mov     dword ptr _leftoverB,edx    ; Store leftover from B
        shr     edx,16                     ; Move rest of data down
        or      edx,ecx                    ; Merge with leftover
        mov     dword ptr [_bltBDAT],edx   ; Store data from B
blitincfill3:



blitincfill3x:
	test    eax,02000000h                       ; Test dma C
        jz      blitincfill4
	mov     ecx,dword ptr [_bltCpt]
        mov     edx,dword ptr _cmem-2+ecx
        bswap   edx                            ; Move my data down
        cmp     esi,1                          ; last word??
        jne     blitincfillh
        mov     ebx,dword ptr _bltCMOD         ; BLTCMOD
        add     ecx,ebx
blitincfillh:
        add     ecx,ebp
        and     ecx,01ffffeh
	mov     dword ptr [_bltCpt],ecx
	mov     dword ptr [_bltCDAT],edx           ; Store data from C

; Now the data lies in BLTXDAT registers
blitincfill4:
        push    eax
        mov     edx,dword ptr _bltcdat
	mov     ecx,dword ptr _bltbdat
	mov     ebx,dword ptr _bltadat
        call    dword ptr [_bltminterm]

        mov     edx,eax
        pop     eax
        and     edx,0ffffh
; Now we have the result
; Do fill

        test    eax,4                   ; test if FC bit is set
        jnz     blitincafc1
	mov     bx,word ptr _fillincfc0[edx*2] ; Get inc,fc0
	mov     dl,byte ptr _fillincfc0after[edx] ; get fc bit after
        jmp     blitincfillafter
blitincafc1:
	mov     bx,word ptr _fillincfc1[edx*2] ; Get inc,fc0
	mov     dl,byte ptr _fillincfc1after[edx] ; get fc bit after
blitincfillafter:
        shl     dl,2            ; Inject FC bit into saved bltcon
	and     al,0fbh
	or      al,dl
	mov     byte ptr _bltfillbltconsave,al
	mov     eax,dword ptr _bltfillbltconsave
	or	dword ptr [_bltzero],ebx

	test	eax,01000000h				; Test DMA D
	jz	blitincfillDoff

	mov     ecx,dword ptr [_bltDpt]
        mov     byte ptr [_cmem + ecx],bh
        mov     byte ptr [_cmem + 1 + ecx],bl
        add     ecx,ebp

	
	cmp     esi,1
        jne     blitincfillj
	mov     ebx,dword ptr [_bltDMOD]
        add     ecx,ebx
blitincfillj:
        and     ecx,01ffffeh
        mov     dword ptr [_bltDpt],ecx
blitincfilli:
blitincfillDoff:		
	dec     esi
        jnz     blitincfillword
	dec     dword ptr _linecount
        jnz     blitterincfillline
        jmp     blitterfillend


                ALIGN32

blitterexfillline:
	mov     esi,dword ptr _linelength
	mov     eax,dword ptr _bltcon
	mov     dword ptr _bltfillbltconsave,eax
	mov     ebp,dword ptr _bltdesc
blitexfillword:
blitexfill1:
	test    eax,08000000h                       ; Test dma A
        jz      blitexfill2
	mov     ecx,dword ptr [_bltApt]
	mov     edx,dword ptr [_cmem+ecx]  ;[_cmem-2+ecx]
        bswap   edx                     ; My word is now in bits 31-16
        cmp     esi,dword ptr _linelength  ; Do first word masking
        jne     blitexfilld
	and     edx,dword ptr [_bltAFWM]
blitexfilld:
        cmp     esi,1                      ; Do last word masking+ modulo
        jne     blitexfillf
	mov     ebx,dword ptr [_bltAMOD]          ; BLTMOD oppdateres DESC
        add     ecx,ebx
        and     edx,dword ptr [_bltALWM]   ; Mask is mirrored in lo/hi word
blitexfillf:
        add     ecx,ebp                    ; Add +2 or -2 to ptA
        and     edx,0ffff0000h             ; Take away garbage
        and     ecx,01ffffeh               ; For safety
        mov     dword ptr [_bltApt],ecx
        mov     ecx,eax                    ; Move saved bltcon to ecx
        shr     ecx,28                     ; Exctract shift for A

        test    eax,2        ; Test desc mode
        jz      blitexnofdesc1
        rol     edx,cl                     ; Rotate to left in desc mode
        jmp     blitexnofdesc2
blitexnofdesc1:
        shr     edx,cl                     ; Shift to right in forward mode
blitexnofdesc2:


        mov     ecx,dword ptr _leftoverA    ; get last leftover
        mov     dword ptr _leftoverA,edx    ; Store leftover from A
        shr     edx,16                     ; Move my shifted  data down
        or      edx,ecx                    ; Merge with leftover
        mov     dword ptr [_bltADAT],edx   ; Store data from A
        jmp     blitexfill2a

; DMA A off
blitexfill2:
        mov     edx,dword ptr _bltadatoriginal
        shl     edx,16
        cmp     esi,dword ptr _linelength  ; Do first word masking
        jne     befd
	and     edx,dword ptr [_bltAFWM]
befd:
        cmp     esi,1                      ; Do last word masking+ modulo
        jne     beff
	mov     ebx,dword ptr [_bltAMOD]          ; BLTMOD oppdateres DESC
        add     ecx,ebx
        and     edx,dword ptr [_bltALWM]   ; Mask is mirrored in lo/hi word
beff:
        mov     ecx,eax                    ; Move saved bltcon to ecx
        shr     ecx,28                     ; Exctract shift for A

        test    eax,2        ; Test desc mode
        jz      befdesc1
        rol     edx,cl                     ; Rotate to left in desc mode
        jmp     befdesc2
befdesc1:
        shr     edx,cl                     ; Shift to right in forward mode
befdesc2:


        mov     ecx,dword ptr _leftoverA    ; get last leftover
        mov     dword ptr _leftoverA,edx    ; Store leftover from A
        shr     edx,16                     ; Move my shifted  data down
        or      edx,ecx                    ; Merge with leftover
        mov     dword ptr [_bltADAT],edx   ; Store data from A


blitexfill2a:


        test    eax,04000000h              ; Test dma B
        jz      blitexfill3
	mov     ecx,dword ptr [_bltBpt]
	mov     edx,dword ptr [_cmem-2+ecx]
        bswap   edx                        ; My data in lo word
        cmp     esi,1                      ; Do modulo if last word on line 
        jne     blitexfillg
        mov     ebx,dword ptr [_bltBMOD]   ; BLTBMOD
        add     ecx,ebx
blitexfillg:
        add     ecx,ebp                    ; Add ptB with +2 or -2
        and     ecx,01ffffeh               ; For safety
        mov     dword ptr [_bltBpt],ecx    ; Save ptB
        mov     ecx,eax                    ; Extract shift for B
	shr     ecx,12
        and     ecx,0fh
        shl     edx,16                     ; Move my data up, lo is clean

        test    eax,2                      ; Rotate or shift
        jz      blitexnofdesc3
        rol     edx,cl
        jmp     blitexnofdesc4
blitexnofdesc3:
        shr     edx,cl
blitexnofdesc4:


        mov     ecx,dword ptr _leftoverB    ; Old leftover
        mov     dword ptr _leftoverB,edx    ; Store leftover from B
        shr     edx,16                     ; Move rest of data down
        or      edx,ecx                    ; Merge with leftover
        mov     dword ptr [_bltBDAT],edx   ; Store data from B

blitexfill3:

blitexfill3a:
	test    eax,02000000h                       ; Test dma C
        jz      blitexfill4
	mov     ecx,dword ptr [_bltCpt]
        mov     edx,dword ptr _cmem-2+ecx
        bswap   edx                            ; Move my data down
        cmp     esi,1                          ; last word??
        jne     blitexfillh
        mov     ebx,dword ptr _bltCMOD         ; BLTCMOD
        add     ecx,ebx
blitexfillh:
        add     ecx,ebp
        and     ecx,01ffffeh
	mov     dword ptr [_bltCpt],ecx
	mov     dword ptr [_bltCDAT],edx           ; Store data from C

; Now the data lies in BLTXDAT registers
blitexfill4:

        push    eax
        mov     edx,dword ptr _bltcdat
        mov     ecx,dword ptr _bltbdat
	mov     ebx,dword ptr _bltadat
        call    dword ptr [_bltminterm]

        mov     edx,eax
        pop     eax
        and     edx,0ffffh

; Now we have the result
; Do fill

        test    eax,4                   ; test if FC bit is set
        jnz     blitexafc1
        mov     bx,word ptr _fillexcfc0[edx*2] ; Get inc,fc0
        mov     dl,byte ptr _fillexcfc0after[edx] ; get fc bit after
        jmp     blitexfillafter
blitexafc1:
        mov     bx,word ptr _fillexcfc1[edx*2] ; Get inc,fc0
        mov     dl,byte ptr _fillexcfc1after[edx] ; get fc bit after
blitexfillafter:
        shl     dl,2            ; Inject FC bit into saved bltcon
	and     al,0fbh
	or      al,dl
	mov     byte ptr _bltfillbltconsave,al
	mov     eax,dword ptr _bltfillbltconsave
	or	dword ptr [_bltzero],ebx

	test	eax,01000000h					; Test DMA D 
	jz	blitexfillDoff
		
	mov     ecx,dword ptr [_bltDpt]
        mov     byte ptr _cmem+ecx,bh
        mov     byte ptr _cmem+1+ecx,bl
        add     ecx,ebp
	cmp     esi,1
        jne     blitexfillj
	mov     ebx,dword ptr [_bltDMOD]
        add     ecx,ebx
blitexfillj:
        and     ecx,01ffffeh
        mov     dword ptr [_bltDpt],ecx
blitexfilli:
blitexfillDoff:
	dec     esi
        jnz     blitexfillword
	dec     dword ptr _linecount
        jnz     blitterexfillline
        jmp     blitterfillend



                ALIGN32


; Fill routine optimized for AD


public ADblitterfillline_
ADblitterfillline_:
        mov     eax,dword ptr _bltcon
	mov     dword ptr _bltfillbltconsave,eax
        test    eax,8
        jz      ADblitterfillexclusive

ADblitterincfillline:
	mov     esi,dword ptr _linelength
	mov     eax,dword ptr _bltcon
	mov     dword ptr _bltfillbltconsave,eax
	mov     ebp,dword ptr _bltdesc
ADblitterincfillword:
ADblitincfill1:
	mov     ecx,dword ptr [_bltApt]
	mov     edx,dword ptr [_cmem+ecx]  ;[_cmem-2+ecx]
        bswap   edx                     ; My word is now in bits 31-16

        cmp     esi,dword ptr _linelength  ; Do first word masking
        jne     ADblitincfilld
	and     edx,dword ptr [_bltAFWM]
ADblitincfilld:
        cmp     esi,1                      ; Do last word masking+ modulo
        jne     ADblitincfillf
	mov     ebx,dword ptr [_bltAMOD]          ; BLTMOD oppdateres DESC
        add     ecx,ebx
        and     edx,dword ptr [_bltALWM]   ; Mask is mirrored in lo/hi word
ADblitincfillf:
        add     ecx,ebp                    ; Add +2 or -2 to ptA
        and     edx,0ffff0000h             ; Take away garbage
        and     ecx,01ffffeh               ; For safety
        mov     dword ptr [_bltApt],ecx
        mov     ecx,eax                    ; Move saved bltcon to ecx
        shr     ecx,28                     ; Exctract shift for A

        test    eax,2        ; Test desc mode
        jz      ADblitincnofdesc1
        rol     edx,cl                     ; Rotate to left in desc mode
        jmp     ADblitincnofdesc2
ADblitincnofdesc1:
        shr     edx,cl                     ; Shift to right in forward mode
ADblitincnofdesc2:


        mov     ecx,dword ptr _leftoverA    ; get last leftover
        mov     dword ptr _leftoverA,edx    ; Store leftover from A
        shr     edx,16                     ; Move my shifted  data down
        or      edx,ecx                    ; Merge with leftover
        mov     dword ptr [_bltADAT],edx   ; Store data from A

ADblitincfill2:

; Now the data lies in BLTXDAT registers
ADblitincfill4:

        push    eax
	mov     edx,dword ptr _bltcdat
        mov     ecx,dword ptr _bltbdat
	mov     ebx,dword ptr _bltadat
        call    dword ptr [_bltminterm]
        mov     edx,eax
        pop     eax
        and     edx,0ffffh

; Now we have the result


        test    eax,4                   ; test if FC bit is set
        jnz     ADblitincafc1
	mov     bx,word ptr _fillincfc0[edx*2] ; Get inc,fc0
	mov     dl,byte ptr _fillincfc0after[edx] ; get fc bit after
        jmp     ADblitincfillafter
ADblitincafc1:
	mov     bx,word ptr _fillincfc1[edx*2] ; Get inc,fc0
	mov     dl,byte ptr _fillincfc1after[edx] ; get fc bit after
ADblitincfillafter:
        shl     dl,2            ; Inject FC bit into saved bltcon
	and     al,0fbh
	or      al,dl
	mov     byte ptr _bltfillbltconsave,al


	mov     eax,dword ptr _bltfillbltconsave

	mov     ecx,dword ptr [_bltDpt]
	or	dword ptr [_bltzero],ebx
        mov     byte ptr _cmem+ecx,bh
        mov     byte ptr _cmem+1+ecx,bl
        add     ecx,ebp
        and     ecx,01ffffeh
        mov     dword ptr [_bltDpt],ecx
ADblitincfilli:
	dec     esi
        jnz     ADblitterincfillword
	mov     ebx,dword ptr [_bltDMOD]
        add     ecx,ebx
        and     ecx,01ffffeh
        mov     dword ptr [_bltDpt],ecx

        dec     dword ptr _linecount
        jnz     ADblitterincfillline
        jmp     blitterfillend


                ALIGN32


ADblitterfillexclusive:
ADblitterexcfillline:
	mov     esi,dword ptr _linelength
	mov     eax,dword ptr _bltcon
	mov     dword ptr _bltfillbltconsave,eax
	mov     ebp,dword ptr _bltdesc
ADblitterexcfillword:
ADblitexcfill1:
	mov     ecx,dword ptr [_bltApt]
	mov     edx,dword ptr [_cmem+ecx]  ;[_cmem-2+ecx]
        bswap   edx                     ; My word is now in bits 31-16

        cmp     esi,dword ptr _linelength  ; Do first word masking
        jne     ADblitexcfilld
	and     edx,dword ptr [_bltAFWM]
ADblitexcfilld:
        cmp     esi,1                      ; Do last word masking+ modulo
        jne     ADblitexcfillf
	mov     ebx,dword ptr [_bltAMOD]          ; BLTMOD oppdateres DESC
        add     ecx,ebx
        and     edx,dword ptr [_bltALWM]   ; Mask is mirrored in lo/hi word
ADblitexcfillf:
        add     ecx,ebp                    ; Add +2 or -2 to ptA
        and     edx,0ffff0000h             ; Take away garbage
        and     ecx,01ffffeh               ; For safety
        mov     dword ptr [_bltApt],ecx
        mov     ecx,eax                    ; Move saved bltcon to ecx
        shr     ecx,28                     ; Exctract shift for A

        test    eax,2        ; Test desc mode
        jz      ADblitexcnofdesc1
        rol     edx,cl                     ; Rotate to left in desc mode
        jmp     ADblitexcnofdesc2
ADblitexcnofdesc1:
        shr     edx,cl                     ; Shift to right in forward mode
ADblitexcnofdesc2:


        mov     ecx,dword ptr _leftoverA    ; get last leftover
        mov     dword ptr _leftoverA,edx    ; Store leftover from A
        shr     edx,16                     ; Move my shifted  data down
        or      edx,ecx                    ; Merge with leftover
        mov     dword ptr [_bltADAT],edx   ; Store data from A

ADblitexcfill2:

; Now the data lies in BLTXDAT registers
ADblitexcfill4:

        push    eax
	mov     edx,dword ptr _bltcdat
	mov     ecx,dword ptr _bltbdat
	mov     ebx,dword ptr _bltadat
        call    dword ptr [_bltminterm]

        mov     edx,eax
        pop     eax
        and     edx,0ffffh

; Now we have the result


        test    eax,4                   ; test if FC bit is set
        jnz     ADblitexcafc1
        mov     bx,word ptr _fillexcfc0[edx*2] ; Get exc,fc0
        mov     dl,byte ptr _fillexcfc0after[edx] ; get fc bit after
        jmp     ADblitexcfillafter
ADblitexcafc1:
        mov     bx,word ptr _fillexcfc1[edx*2] ; Get exc,fc0
        mov     dl,byte ptr _fillexcfc1after[edx] ; get fc bit after
ADblitexcfillafter:
        shl     dl,2            ; Inject FC bit into saved bltcon
	and     al,0fbh
	or      al,dl
	mov     byte ptr _bltfillbltconsave,al


	mov     eax,dword ptr _bltfillbltconsave

	mov     ecx,dword ptr [_bltDpt]
	or	dword ptr [_bltzero],ebx
        mov     byte ptr _cmem+ecx,bh
        mov     byte ptr _cmem+1+ecx,bl
        add     ecx,ebp
        and     ecx,01ffffeh
        mov     dword ptr [_bltDpt],ecx
ADblitexcfilli:
	dec     esi
        jnz     ADblitterexcfillword
	mov     ebx,dword ptr [_bltDMOD]
        add     ecx,ebx
        and     ecx,01ffffeh
        mov     dword ptr [_bltDpt],ecx

        dec     dword ptr _linecount
        jnz     ADblitterexcfillline



blitterfillend:
        test    dword ptr _bltcon,008000000h
        jz      bliend1
        mov     edx,dword ptr _bltadatoriginal
        mov     dword ptr _bltadat,edx
bliend1:
        mov     edx,08040h
	mov     ecx,0dff09ch
	call    wriw

	ret








; ===========================================
; Blitter COPY
; ===========================================

; -----------------------------------------------------------------------------
; Do one line of blitter copy operation
; Not LINEMODE!  Stupid labelname.
; This is the general routine called in case there isn't an optimized routine.
; -----------------------------------------------------------------------------

                ALIGN32

blitter_normal:

public blitterline_
blitterline_:
	mov     esi,dword ptr _linelength
	mov     ebp,dword ptr _bltdesc
blitterword:
	mov     eax,dword ptr _bltcon
blit1:
	test    eax,01000000h
	jz      bliti
	test    eax,08000000h                       ; Test dma A
	jz      blit2
	mov     ecx,dword ptr [_bltApt]
	mov     edx,dword ptr [_cmem+ecx]  ;[_cmem-2+ecx]
	bswap   edx

        cmp     esi,dword ptr _linelength
        jne     blitd
        and     edx,dword ptr [_bltAFWM]
blitd:  cmp     esi,1
	jne     blitf
	mov     ebx,dword ptr [_bltAMOD]          ; BLTMOD oppdateres DESC
	add     ecx,ebx
	and     edx,dword ptr [_bltALWM]
blitf:  add     ecx,ebp
	and     edx,0ffff0000h
	mov     dword ptr [_bltApt],ecx
	mov     ecx,eax
	shr     ecx,28
        test    eax,2
        jz      nodesc1
        rol     edx,cl
        jmp     nodesc2
nodesc1:
        shr     edx,cl
nodesc2:
	mov     ecx,dword ptr _leftoverA
	mov     dword ptr _leftoverA,edx         ; Store leftover from A
	shr     edx,16
	or      edx,ecx                         ; Merge leftover

        and     edx,0ffffh
	mov     dword ptr [_bltADAT],edx           ; Store data from A
        jmp     blit90
blit2:

        mov     edx,dword ptr _bltadatoriginal
        shl     edx,16
        cmp     esi,dword ptr _linelength  ; Do first word masking
        jne     bnorbd
	and     edx,dword ptr [_bltAFWM]
bnorbd:
        cmp     esi,1                      ; Do last word masking+ modulo
        jne     bnorbf
	mov     ebx,dword ptr [_bltAMOD]          ; BLTMOD oppdateres DESC
        add     ecx,ebx
        and     edx,dword ptr [_bltALWM]   ; Mask is mirrored in lo/hi word
bnorbf:
        mov     ecx,eax                    ; Move saved bltcon to ecx
        shr     ecx,28                     ; Exctract shift for A

        test    eax,2        ; Test desc mode
        jz      bnordesc1
        rol     edx,cl                     ; Rotate to left in desc mode
        jmp     bnordesc2
bnordesc1:
        shr     edx,cl                     ; Shift to right in forward mode
bnordesc2:


        mov     ecx,dword ptr _leftoverA    ; get last leftover
        mov     dword ptr _leftoverA,edx    ; Store leftover from A
        shr     edx,16                     ; Move my shifted  data down
        or      edx,ecx                    ; Merge with leftover
        mov     dword ptr [_bltADAT],edx   ; Store data from A


blit90:
	test    eax,04000000h                       ; Test dma B
	jz      blit3
	mov     ecx,dword ptr [_bltBpt]
        mov     edx,dword ptr [_cmem+ecx]
	bswap   edx
	cmp     esi,1                           ; Last word??
	jne     blitg
	mov     ebx,dword ptr [_bltBMOD]        ; BLTMOD oppdateres DESC
	add     ecx,ebx
blitg:  add     ecx,ebp
	mov     dword ptr [_bltBpt],ecx
	mov     ecx,eax
	shr     ecx,12
        and     ecx,0fh 
        and     edx,0ffff0000h
        test    eax,2
        jz      nodesc3
        rol     edx,cl
        jmp     nodesc4
nodesc3:
	shr     edx,cl
nodesc4:
	mov     ecx,dword ptr _leftoverB
	mov     dword ptr _leftoverB,edx         ; Store leftover from B
	shr     edx,16
	or      edx,ecx
        and     edx,0ffffh
        mov     dword ptr [_bltBDAT],edx           ; Store data from B
blit3:

blit80:
	test    eax,02000000h                       ; Test dma C
	jz      blit4
	mov     ecx,dword ptr [_bltCpt]
	mov     edx,dword ptr _cmem-2+ecx
	bswap   edx
	cmp     esi,1                           ; Last word??
	jne     blith
	mov     ebx,dword ptr _bltCMOD         ; BLTMOD oppdateres DESC
	add     ecx,ebx
blith:  add     ecx,ebp
	mov     dword ptr [_bltCpt],ecx
        and     edx,0ffffh
	mov     dword ptr [_bltCDAT],edx           ; Store data from C

; Now the data lies in BLTXDAT registers
blit4:
	mov     edx,dword ptr _bltcdat
	mov     ecx,dword ptr _bltbdat
	mov     ebx,dword ptr _bltadat
        call    dword ptr [_bltminterm]
	or	dword ptr [_bltzero],eax


; Now we have the result

	test	byte ptr [_bltcon + 3],01h
	jz	blitDoff
		
	mov     ecx,dword ptr [_bltDpt]

        mov     byte ptr _cmem+ecx,ah
        mov     byte ptr _cmem+1+ecx,al
	add     ecx,ebp
	cmp     esi,1
	jne     blitj
	mov     ebx,dword ptr [_bltDMOD]
	add     ecx,ebx
blitj:  mov     dword ptr [_bltDpt],ecx
blitDoff:
bliti:  dec     esi
	jnz     blitterword
	dec     dword ptr _linecount
	jnz     blitterline_



; restore blitter registers

        test    dword ptr _bltcon,008000000h
        jz      bliend3
        mov     edx,dword ptr _bltadatoriginal
        mov     dword ptr _bltadat,edx
bliend3:
        test    dword ptr _bltcon,004000000h
        jz      bliend4
        mov     edx,dword ptr _bltbdatoriginal
        mov     dword ptr _bltbdat,edx
bliend4:


        mov     edx,08040h
	mov     ecx,0dff09ch
	call    wriw

	ret


; ------------------------------------------
; Do one line of blitter operation
; Optimized for AD
; Doesn't accept decending mode (Later note:	 ???!?)
; ------------------------------------------

                ALIGN32

public ADblitterline_        
ADblitterline_:        
	mov     esi,dword ptr _linelength
	mov     ebp,dword ptr _bltdesc
ADblitterword:
	mov     eax,dword ptr _bltcon
	mov     ecx,dword ptr [_bltApt]
        mov     edx,dword ptr [_cmem+ecx]  ;[_cmem-2+ecx]
	bswap   edx
	cmp     esi,dword ptr _linelength
	jne     ADblitd
	and     edx,dword ptr [_bltAFWM]
ADblitd:cmp     esi,1                            ; Last word in line
        jne     ADblitf                          ; so
        mov     ebx,dword ptr [_bltAMOD]         ; add modulo
	add     ecx,ebx
	and     edx,dword ptr [_bltALWM]
ADblitf:
        add     ecx,ebp
ADblargh2:
	and     edx,0ffff0000h
	mov     dword ptr [_bltApt],ecx
	mov     ecx,eax
	shr     ecx,28
        test    eax,2
        jz      nodesc5
        rol     edx,cl
        jmp     nodesc6
nodesc5:
	shr     edx,cl
nodesc6:
	mov     ecx,dword ptr _leftoverA
	mov     dword ptr _leftoverA,edx         ; Store leftover from A
	shr     edx,16
	or      edx,ecx                         ; Merge leftover
	mov     dword ptr [_bltADAT],edx           ; Store data from A

; Now the data lies in BLTXDAT registers

	mov     edx,dword ptr _bltcdat
	mov     ecx,dword ptr _bltbdat
	mov     ebx,dword ptr _bltadat
        call    dword ptr [_bltminterm] ; Do logic


; Now we have the result
	mov     ecx,dword ptr [_bltDpt]

ADblargh3:
	or	dword ptr [_bltzero],eax
        mov     byte ptr _cmem+ecx,ah
        mov     byte ptr _cmem+1+ecx,al
        add     ecx,ebp
ADblargh4:
	cmp     esi,1
	jne     ADblitj
	mov     ebx,dword ptr [_bltDMOD]
	add     ecx,ebx
ADblitj:mov     dword ptr [_bltDpt],ecx
ADbliti:dec     esi
	jnz     ADblitterword
	dec     dword ptr _linecount
	jnz     ADblitterline_
        mov     edx,08040h
	mov     ecx,0dff09ch
	call    wriw

	ret

; ---------------------------------------
; Do one line of blitter operation
; Optimized for D, maybe a little too optimized.....:-)
; ---------------------------------------

                ALIGN32


public Dblitterline_
Dblitterline_:

	
	mov     edx,dword ptr _bltcdat
	mov     ecx,dword ptr _bltbdat
	mov     ebx,dword ptr _bltadat
        call    dword ptr [_bltminterm] ; Do logic

        bswap   eax
        shr     eax,16
		
	or	dword ptr [_bltzero],eax
	mov     ecx,dword ptr [_bltDpt]
	mov     ebx,dword ptr [_bltDMOD]
	mov     ebp,dword ptr _bltdesc
Dblitterline2:
	mov     esi,dword ptr _linelength
	
Dblitterword:
Dblit1:
Dblargh2:
        mov     word ptr _cmem+ecx,ax
        add     ecx,ebp         ; Add 2 BLTDPT,
Dblargh:
	dec     esi
        jnz     Dblitterword    ; Do another word

	add     ecx,ebx
	dec     dword ptr _linecount
	jnz     Dblitterline2
	mov     dword ptr _bltDpt,ecx


        mov     edx,08040h
	mov     ecx,0dff09ch
	call    wriw

	ret

; ===========================================================
; Blitter COPY ENDS
; ===========================================================


; ========================================================
; Blitter logic functions
; ========================================================

; -------------------------------------
; The general blitter logic function
; Takes A in ebx, B in ecx and C in edx
; Result in eax 
; -------------------------------------

	
		ALIGN32


public blit_min_generic_
blit_min_generic_:
		push	ebp
		push	edi
		xor	ebp,ebp
		mov	edi,dword ptr [_bltcon + 2]
		xor	eax,eax
		test	edi,80h				; Minterm ABC
		jz	blit5
		mov	ebp,ebx
		and	ebp,ecx
		and	ebp,edx
		or	eax,ebp
blit5:		not	edx				; minterm ABc
		test	edi,40h                           
		jz	blit6
		mov	ebp,ebx
		and	ebp,ecx
		and	ebp,edx
		or	eax,ebp
blit6:		not	edx				; minterm AbC
		not	ecx
		test	edi,20h                           
		jz	blit7
		mov	ebp,ebx
		and	ebp,ecx
		and	ebp,edx
		or	eax,ebp
blit7:		not	edx				; minterm Abc
		test	edi,10h                           
		jz	blit8
		mov	ebp,ebx
		and	ebp,ecx
		and	ebp,edx
		or	eax,ebp
blit8:		not	edx				; minterm aBC
		not	ecx
		not	ebx
		test	edi,08h
		jz	blit9
		mov	ebp,ebx
		and	ebp,ecx
		and	ebp,edx
		or	eax,ebp
blit9:		not	edx				; minterm aBc
		test	edi,04h
		jz	blita
		mov	ebp,ebx
		and	ebp,ecx
		and	ebp,edx
		or	eax,ebp
blita:		not	edx				; minterm abC
		not	ecx
		test	edi,02h
		jz	blitb
		mov	ebp,ebx
		and	ebp,ecx
		and	ebp,edx
		or	eax,ebp
blitb:		not	edx				; minterm abc
		test	edi,01h
		jz	blitcc
		mov	ebp,ebx
		and	ebp,ecx
		and	ebp,edx
		or	eax,ebp
blitcc:		not	ebx
		not	ecx
		not	edx
		pop	edi
		pop	ebp
		ret


; -------------------------------------------------
; Optimized logic functions for some common cases
; Must not destroy the parameters
; in:  A - ebx   B - ecx  C - edx
; out: D - eax 
; -------------------------------------------------


		ALIGN32

; 0

public blit_min_00_
blit_min_00_:	xor	eax,eax
		ret


		ALIGN32

; !(A+B+C)

public blit_min_01_
blit_min_01_:	mov	eax,ebx
		or	eax,ecx
		or	eax,edx
		not	eax
		ret


		ALIGN32

; abC

public blit_min_02_
blit_min_02_:	not	ebx
		mov	eax,edx
		not	ecx
		and	eax,ebx
		not	ebx
		and	eax,ecx
		not	ecx
		ret


		ALIGN32

; !(A+B)

public blit_min_03_
blit_min_03_:	mov	eax,ebx
		or	eax,ecx
		not	eax
		ret


		ALIGN32

; aBc

public blit_min_04_
blit_min_04_:	not	ebx
		mov	eax,ecx
		not	edx
		and	eax,ebx
		not	ebx
		and	eax,edx
		not	edx
		ret


		ALIGN32

; !(A+C)

public blit_min_05_
blit_min_05_:	mov	eax,edx
		or	eax,ebx
		not	eax
		ret


		ALIGN32

; a(B xor C)

public blit_min_06_
blit_min_06_:	mov	eax,ebx
		xor	ecx,edx
		not	eax
		and	eax,ecx
		xor	ecx,edx
		ret


		ALIGN32

; !(A+BC)

public blit_min_07_
blit_min_07_:	mov	eax,ecx
		and	eax,edx
		or	eax,ebx
		not	eax
		ret


		ALIGN32

; aBC

public blit_min_08_
blit_min_08_:	not	ebx
		mov	eax,edx
		and	eax,ebx
		not	ebx
		and	eax,ecx
		ret      


		ALIGN32

; !(A+(B xor C))

public blit_min_09_
blit_min_09_:	mov	eax,ecx
		xor	eax,edx
		or	eax,ebx
		not	eax
		ret


		ALIGN32

; Ca

public blit_min_0a_
blit_min_0a_:	mov	eax,ebx
		not	eax
		and	eax,edx
		ret


		ALIGN32

; !(B+C) + Ca

public blit_min_0b_
blit_min_0b_:	push	ebx
		mov	eax,edx
		or	eax,ecx
		not	eax
		not	ebx
		and	ebx,edx
		or	eax,ebx
		pop	ebx
		ret


		ALIGN32

; Ba

public blit_min_0c_
blit_min_0c_:	mov	eax,ebx
		not	eax
		and	eax,ecx
		ret


		ALIGN32

; !(A+(bC))

public blit_min_0d_
blit_min_0d_:	mov	eax,ecx
		not	eax
		and	eax,edx
		or	eax,ebx
		not	eax
		ret


		ALIGN32

; a(B+C)

public blit_min_0e_
blit_min_0e_:	mov	eax,ecx
		not	ebx
		or	eax,edx
		and	eax,ebx
		not	ebx
		ret


		ALIGN32

; a

public blit_min_0f_
blit_min_0f_:	mov	eax,ebx
		not	eax
		ret


		ALIGN32

; (!AB)C

public blit_min_2a_
blit_min_2a_:	mov	eax,ebx
		and	eax,ecx
		not	eax
		and	eax,edx
		ret


		ALIGN32

; aC + ABc

public blit_min_4a_
blit_min_4a_:	push	edx
		mov	eax,ebx
		not	eax
		and	eax,edx
		not	edx
		and	edx,ebx
		and	edx,ecx
		or	eax,edx
		pop	edx
		ret


		ALIGN32

; AB + aC

public blit_min_ca_
blit_min_ca_:	push	ebx
		mov	eax,ebx
		not	ebx
		and	eax,ecx
		and	ebx,edx
		or	eax,ebx
		pop	ebx
		ret
		

		ALIGN32

; Ac + BC

public blit_min_d8_
blit_min_d8_:	push	ebx
		mov	eax,edx
		not	edx
		and	eax,ecx
		and	ebx,edx
		or	eax,ebx
		not	edx
		pop	ebx
		ret


		ALIGN32

; AB+aC+AbC

public blit_min_ea_
blit_min_ea_:	push	ecx
		push	ebx
		mov	eax,ebx
		and	eax,ecx
		not	ecx
		and	ecx,ebx
		and	ecx,edx
		not	ebx
		and	ebx,edx
		or	eax,ebx
		or	eax,ecx
		pop	ebx
		pop	ecx
		ret


		ALIGN32

;A

public blit_min_f0_
blit_min_f0_:	mov	eax,ebx
		ret


		ALIGN32

; C + A

public blit_min_fa_
blit_min_fa_:	mov	eax,ebx
		or	eax,edx
		ret


		ALIGN32

;A + aB

public blit_min_fc_
blit_min_fc_:	mov	eax,ebx
		not	eax
		and	eax,ecx
		or	eax,ebx
		ret


		ALIGN32

; 1

public blit_min_ff_
blit_min_ff_:	mov	eax,-1
		ret


; ============================================================================
; Blitter logic ENDS
; ============================================================================


ALIGN32

_TEXT ends

_DATA segment dword public 'DATA'

include data\blit.inc
include data\bus.inc
include data\copper.inc
include data\memory.inc
include data\68000.inc
			
_DATA ends

_BSS segment dword public 'DATA'
_BSS ends

end

