/* Generic list */

typedef struct _list {
  struct _list *next;
  struct _list *prev;
  void *node;
} list;

list *listNew(void *node);
list *listAddFirst(list *root, list *l);
list *listAddLast(list *root, list *l);
list *listAddSorted(list *root, list *l, int (*comp)(void *, void *));
list *listNext(list *l);
list *listPrev(list *l);
list *listLast(list *l);
list *listCat(list *l1, list *l2);
ULO listCount(list *l);
void *listNode(list *l);
void listRemove(list *l);
void listFree(list *node);

/* Generic tree */

typedef struct _tree {
  struct _tree *parent;
  struct _tree *child;
  void *node;
  list *lnode;
} tree;

tree *treeNew(tree *parent, void *node);
void treeChild_add(tree *t, tree *child);
tree *treeChild(tree *t);
tree *treeSisterNext(tree *t);
tree *treeSisterPrev(tree *t);
void *treeNode(tree *t);
tree *treeParent(tree *t);
ULO treeChildCount(tree *t);
