/****************************************************************************
 MEMORY RELATED FUNCTIONS
 ****************************************************************************/
/* Functions implemented in ma.asm */

/* TOP LEVEL INTERFACE */
extern ULO fetb(amigaadress ea);
extern ULO fetw(amigaadress ea);
extern ULO fetl(amigaadress ea);
extern void wrib(ULO data, amigaadress ea);
extern void wriw(ULO data, amigaadress ea);
extern void wril(ULO data, amigaadress ea);

/* CHIP RAM INTERFACE */
extern ULO readchipbyte(amigaadress ea);
extern ULO readchipword(amigaadress ea);
extern ULO readchiplong(amigaadress ea);
extern void writechipbyte(ULO data, amigaadress ea);
extern void writechipword(ULO data, amigaadress ea);
extern void writechiplong(ULO data, amigaadress ea);

/* FAST RAM INTERFACE */
extern ULO readfastbyte(amigaadress ea);
extern ULO readfastword(amigaadress ea);
extern ULO readfastlong(amigaadress ea);
extern void writefastbyte(ULO data, amigaadress ea);
extern void writefastword(ULO data, amigaadress ea);
extern void writefastlong(ULO data, amigaadress ea);

/* BOGO RAM INTERFACE */
extern ULO readbogobyte(amigaadress ea);
extern ULO readbogoword(amigaadress ea);
extern ULO readbogolong(amigaadress ea);
extern void writebogobyte(ULO data, amigaadress ea);
extern void writebogoword(ULO data, amigaadress ea);
extern void writebogolong(ULO data, amigaadress ea);

/* KICK ROM INTERFACE */
extern ULO readkickbyteaf(amigaadress ea);
extern ULO readkickwordaf(amigaadress ea);
extern ULO readkicklongaf(amigaadress ea);
extern ULO readkickbyte(amigaadress ea);
extern ULO readkickword(amigaadress ea);
extern ULO readkicklong(amigaadress ea);
extern void writekickbyte(ULO data, amigaadress ea);
extern void writekickword(ULO data, amigaadress ea);
extern void writekicklong(ULO data, amigaadress ea);

extern ULO readlkickbyte(amigaadress ea);
extern ULO readlkickword(amigaadress ea);
extern ULO readlkicklong(amigaadress ea);

/* IO REGISTER INTERFACE */
extern ULO readregisterbyte(amigaadress ea);
extern ULO readregisterword(amigaadress ea);
extern ULO readregisterlong(amigaadress ea);
extern void writeregisterbyte(ULO data, amigaadress ea);
extern void writeregisterword(ULO data, amigaadress ea);
extern void writeregisterlong(ULO data, amigaadress ea);

/* CIA INTERFACE */
extern ULO readciabyte(amigaadress ea);
extern ULO readciaword(amigaadress ea);
extern ULO readcialong(amigaadress ea);
extern void writeciabyte(ULO data, amigaadress ea);
extern void writeciaword(ULO data, amigaadress ea);
extern void writecialong(ULO data, amigaadress ea);

/* NOT AVAILABLE INTERFACE */
extern ULO readNAbyte(amigaadress ea);
extern ULO readNAword(amigaadress ea);
extern ULO readNAlong(amigaadress ea);
extern void writeNAbyte(ULO data, amigaadress ea);
extern void writeNAword(ULO data, amigaadress ea);
extern void writeNAlong(ULO data, amigaadress ea);

/* Mystery (SCSI..?) INTERFACE */
extern ULO readMysterybyte(amigaadress ea);
extern ULO readMysteryword(amigaadress ea);
extern ULO readMysterylong(amigaadress ea);
extern void writeMysterybyte(ULO data, amigaadress ea);
extern void writeMysteryword(ULO data, amigaadress ea);
extern void writeMysterylong(ULO data, amigaadress ea);

extern void oddwrite(ULO data,amigaadress ea);
extern ULO oddread(amigaadress ea);

extern ULO wvpos();
extern ULO rid();

extern ULO rdmaconr();
extern ULO rvposr();
extern ULO rvhposr();
extern ULO rdskbytr();
extern ULO rserdatr();
extern ULO rintenar();
extern ULO rintreqr();
extern ULO rcopjmp1();
extern ULO rcopjmp2();
extern ULO rdefault();

extern void wdskpth();
extern void wdskptl();
extern void wdsklen();
extern void wcopcon();
extern void wdsksync();
extern void wcop1lch();
extern void wcop1lcl();
extern void wcop2lch();
extern void wcop2lcl();
extern void wcopjmp1();
extern void wcopjmp2();
extern void wdiwstrt();
extern void wdiwstop();
extern void wddfstrt();
extern void wddfstop();
extern void wdmacon();
extern void wintena();
extern void wintreq();
extern void wadcon();
extern void waud0pth();
extern void waud0ptl();
extern void waud0vol();
extern void waud0len();
extern void waud0per();
extern void waud1pth();
extern void waud1ptl();
extern void waud1vol();
extern void waud1len();
extern void waud1per();
extern void waud2pth();
extern void waud2ptl();
extern void waud2vol();
extern void waud2len();
extern void waud2per();
extern void waud3pth();
extern void waud3ptl();
extern void waud3vol();
extern void waud3len();
extern void waud3per();
extern void wbpl1ptl();
extern void wbpl1pth();
extern void wbpl1ptl();
extern void wbpl2pth();
extern void wbpl2ptl();
extern void wbpl3pth();
extern void wbpl3ptl();
extern void wbpl4pth();
extern void wbpl4ptl();
extern void wbpl5pth();
extern void wbpl5ptl();
extern void wbpl6pth();
extern void wbpl6ptl();
extern void wbplcon0();
extern void wbplcon1();
extern void wbplcon2();
extern void wbpl1mod();
extern void wbpl2mod();
extern void wspr0pth();
extern void wspr0ptl();
extern void wspr1pth();
extern void wspr1ptl();
extern void wspr2pth();
extern void wspr2ptl();
extern void wspr3pth();
extern void wspr3ptl();
extern void wspr4pth();
extern void wspr4ptl();
extern void wspr5pth();
extern void wspr5ptl();
extern void wspr6pth();
extern void wspr6ptl();
extern void wspr7pth();
extern void wspr7ptl();
extern void wdefault();
extern void wcolor();

#ifdef CYCLE_EXACT
extern void wcolorcycleexact();
#endif

extern ULO wriorgadr;


