; ===========================================
;  Fellow Amiga Emulator      
;  Support for different LED representations
;  (C) 1997-1998 Petter Schau,
;                Roman Dolejsi
;            and David Voracek
; ===========================================


        .486p
DGROUP group _DATA,_BSS
_TEXT  segment para public use32 'CODE'
       assume cs:_TEXT, ds:DGROUP, ss:DGROUP


public ledstart_
ledstart_:                              ; Used to check code alignment
startlbl:

;-----------------------------------------------

; Translate me to C sometime + clean up structure

; Notes:
; This file also accesses the framebuffer, should add and call
; a routine in drawa.asm that draws a led-box so all "drawing" is
; isolated in the draw files.

; The powerled color is set in memory.c and other places, which is absurd.
; When drawX.X routine is added, just add a parameter to it for
; led type so that the drawing system selects a color.  This file's
; routines shouln't need to worry about colors, just type of led.

include defs.inc

                ALIGN32

; Draw LED symbols

; edx - offset in line (xpos*2)
; ecx - color

public drawled_
drawled_:
                cmp     byte [_config_enableleds], 0
                je      drawleddont
                test    byte [_config_enableleds], 0c0h
                jnz     drawledlpt
                cmp     byte [_config_graphics_mode],5
                ja      drawleddont
drawledscr:     push    eax
                push    ebx
                mov     eax,[_configdoublebuffer]
drawledloop:    push    eax
                push    edx
                add     edx,[_framebuffer]
                add     edx,[_bufferoffsets+4*eax]
                mov     eax, [_config_graphics_mode]
                mov     eax, [eax * 4 + _config_graphics_moderesx]
                add     edx, eax
                add     edx, eax
                add     edx,[_draw_scanlinemodulo]
                mov     ebx,2
drawledloop2:   mov     [edx],ecx
                mov     4[edx],ecx
                mov     8[edx],ecx
                mov     12[edx],ecx
                mov     16[edx],ecx
                mov     20[edx],ecx
                mov     24[edx],ecx
                mov     28[edx],ecx
                add     edx,[_draw_scanlinemodulo]
drawledloop2e:  add     edx, eax
                add     edx, eax
                dec     ebx
                jnz     drawledloop2
                pop     edx
                pop     eax
                dec     eax
                jns     drawledloop
                pop     ebx
                pop     eax
drawleddont:    ret

                ALIGN32

drawledlpt:     push    eax
                push    edx
                test    byte [_config_enableleds], 10h
                jnz     drawledlptmirr
                mov     ah, 80h
                cmp     edx, 100
                je      drawledlpt0
                mov     ah, 1
                cmp     edx, 150
                je      drawledlpt0
                mov     ah, 2
                cmp     edx, 200
                je      drawledlpt0
                mov     ah, 4
                cmp     edx, 250
                je      drawledlpt0
                mov     ah, 8
drawledlpt0:    mov     al, ah
                not     al
                test    ecx, ecx
                jnz     drawledlpt1
                mov     ah, 0
drawledlpt1:    and     al, [_ledbyte]
                or      al, ah
                mov     [_ledbyte], al
                pop     edx
                pop     eax

public  drawledlpt_
drawledlpt_:    push    eax
                push    edx
                mov     al, [_ledbyte]
                test    byte [_config_enableleds], 80h         ; keyboard output ?
                jnz     drawledkbd
                mov     edx, [_ledlpt]
                out     dx, al
                pop     edx
                pop     eax
                ret

                ALIGN32

drawledlptmirr: mov     ah, 1
                cmp     edx, 100
                je      drawledlpt0
                mov     ah, 80h
                cmp     edx, 150
                je      drawledlpt0
                mov     ah, 40h
                cmp     edx, 200
                je      drawledlpt0
                mov     ah, 20h
                cmp     edx, 250
                je      drawledlpt0
                mov     ah, 10h
                jmp     short drawledlpt0

                ALIGN32

drawledkbd:     rol     al, 1
                and     al, 0fh
                movzx   edx, al
                mov     eax, [_config_enableleds]
                dec     al
                and     eax, 3
                shl     eax, 5
                add     edx, eax
                mov     dl, [drawledkbd_tab + edx]
                mov     al, byte ptr [_kbdleds]
                shl     eax, 3
                add     edx, eax
                push    ecx
                mov     ecx, 65536
drawledkbd_w1:  in      al, 61h
                dec     ecx
                jc      drawledkbd_w11
                and     al, 2
                jnz     drawledkbd_w1
drawledkbd_w11: mov     al, 0edh
                out     60h, al
                mov     ecx, 65536
drawledkbd_w2:  in      al, 61h
                dec     ecx
                jc      drawledkbd_w21
                and     al, 2
                jnz     drawledkbd_w2
drawledkbd_w21: mov     al, [drawledkbd_kbd + edx]
                out     60h, al
                pop     ecx
                pop     edx
                pop     eax
                ret

                ALIGN32

public drawoldkbd_
drawoldkbd_:    push    eax
                push    ecx
                mov     ecx, 65536
drawoldkbd_w1:  in      al, 61h
                dec     ecx
                jc      drawoldkbd_w11
                and     al, 2
                jnz     drawoldkbd_w1
drawoldkbd_w11: mov     al, 0edh
                out     60h, al
                mov     ecx, 65536
drawoldkbd_w2:  in      al, 61h
                dec     ecx
                jc      drawoldkbd_w21
                and     al, 2
                jnz     drawoldkbd_w2
drawoldkbd_w21: mov     al, byte ptr ds:[417h]
                shr     al, 4
                and     al, 7
                out     60h, al
                mov     al, 0ffh
                push    edx
                mov     dx, 378h
                out     dx, al
                pop     edx
                pop     ecx
                pop     eax
                ret

                ALIGN32

public drawledhdscr_
drawledhdscr_:  cmp     byte [_config_enableleds], 0
                je      drawledhddont
                cmp     byte [_config_enableleds], 6
                je      drawledhddont
                push    ecx
                push    edx
                xor     ecx, ecx
                test    dword ptr [_ledbyte], 20h
                jz      drawledhdscr1
                mov     ecx, [_hdledcolor]
drawledhdscr1:  mov     edx, 350
                call    drawledscr
                pop     edx
                pop     ecx
drawledhddont:  ret


                ALIGN32

_TEXT ends

_DATA  segment para public use32 'DATA'

include data\inout.inc
include data\graphem.inc
include data\fellow.inc
include data\draw.inc
	
public _config_enableleds
_config_enableleds:     dd      0

public _kbdleds
_kbdleds:               dd      0

public _ledlpt
_ledlpt:                dd      0

; Color for led-symbols 

public _powerledcolor
public _drivemotorcolor
public _hdledcolor

_powerledcolor:         dd      0
_drivemotorcolor:       dd      0
_hdledcolor:            dd      0


drawledkbd_tab  db      0, 0, 2, 2, 4, 4, 6, 6, 1, 1, 3, 3, 5, 5, 7, 7  ; KB1
                db      0, 0, 2, 2, 4, 4, 6, 6, 1, 1, 3, 3, 5, 5, 7, 7
                db      0, 2, 4, 6, 1, 3, 5, 7, 0, 2, 4, 6, 1, 3, 5, 7  ; KB2
                db      0, 2, 4, 6, 1, 3, 5, 7, 0, 2, 4, 6, 1, 3, 5, 7
                db      0, 2, 4, 6, 4, 6, 4, 6, 1, 3, 5, 7, 5, 7, 5, 7  ; KB3
                db      1, 3, 5, 7, 5, 7, 5, 7, 1, 3, 5, 7, 5, 7, 5, 7
drawledkbd_kbd  db      0, 1, 2, 3, 4, 5, 6, 7  ; NCS
                db      0, 4, 2, 6, 1, 5, 3, 7  ; NSC
                db      0, 1, 4, 5, 2, 3, 6, 7  ; CNS
                db      0, 2, 4, 6, 1, 3, 5, 7  ; CSN
                db      0, 2, 1, 3, 4, 6, 5, 7  ; SCN
                db      0, 4, 1, 5, 2, 6, 3, 7  ; SNC

public _ledbyte
_ledbyte:       db       0

_DATA  ends

_BSS  segment para public use32 'BSS'
_BSS  ends

end
